<?php
/*******************************************************************************
* Simple Chart © By Akyhne													   *
********************************************************************************
* SimpleGauge.php V 0.5												           *
*******************************************************************************/


	// Without this, all browsers except IE9+ will not accept external svg stylesheets!
	header('Content-type: image/svg+xml; charset=UTF-8');
	$time_start = microtime_float(true);
	// X = H = width = left/right
	global $centerX, $centerY, $degrees, $set_val, $max_value;

	parse_str(preg_replace('/&amp;/', '&', $_SERVER['QUERY_STRING']), $_GET);
	$gauge_data = $_GET['data'];
	$gauge = preg_split('/[|]/', $gauge_data, -1, PREG_SPLIT_NO_EMPTY);
	foreach ($gauge as $list)
	{
		$list_values = explode(':::', $list);
		// Split and limit to 50 columns!
		$gauge_val[$list_values[0]] = explode(";", $list_values[1], 1);
	}
	$keys = array_keys($gauge_val);
	$max_value = isset($_GET["max"]) ? (float)$_GET["max"] : 0;
	$set_val = (float)$gauge_val[$keys[0]][0];
	$set_val = $max_value > 0 && $set_val > $max_value ? $max_value : ($set_val < 0 ? 0 : $set_val);
	$gauge_desc = $keys[0];

	$centerX = 250;
	$centerY = 250;
	$svg = '';

	$style = isset($_GET['style']) ? strtolower($_GET['style']) : '';
	$style = $style == 'graygauge' || $style == 'speedometer' || $style == 'racer' || $style == 'half' || $style == 'radar' || $style == 'blueglass' || $style == 'temp' || $style == 'kungfu' || $style == 'time' ? $style : 'standard';

	$style_types = array(
		'standard' => array(
			'name' => 'standard', // Not used for anything, just nice to have
			'needle' => 'needle1', // The needle shape to be used
			'dot' => 'normal', // The middle dot of the gauge
			'background' => 'bg1', // This is the entire deffinition of the background
			'part' => array(
				'split_up' => array(10, 10), // First value indicates how many sub parts there should be. If the last value in 'min_max' is set to 300 and this first value is set to 10, the gauge will be split in 10 parts with numbers 30, 60 90 etc. The last value, makes sub parts ex. thin lines
				'start_degree' => 225, //  0 degree = right, 180 degree = left, 90 degree is top. This indicates in what angle the gauge should start from
				'stop_degree' => 315, // Stop degree. 270 is down.
				'inner_rad' => array(160, 160), // Inner radius of stripes. Don't exceed 250!
				'outer_rad' => array(200, 200), // Outer radius of stripes. Don't exceed 250!
				'stroke_width' => array(5, 1), 
				'color' => array('#666', '#888'),
				'min_max' => array(0, 100), // Min. value is not in use. Max value indicates how high the gauge should count
				'text' => array( // All stuff about text values
					'show' => true,
					'font-size' => '18px',
					// 'font-family' => 'Arial, Helvetica, sans-serif', // This is optional. Don't add it, if you don't use it!
					'rad' => 140, // How far from the middle should text go? Don't exceed 250!
					'color' => '#000',
					'rotate' => false, // If set to true, text will be rotated in the same angle as where it is put.
					'offsetY' => '5',
					// 'type' => 'time', // This is optional. Don't add it, if you don't use it!
					'description' => array( // When specifying the BBC like this, [chart layout=gauge]xyz=27[/chart], the xyz is text that will be put into the gauge
						'show' => true,
						'color' => '#000',
						'font-size' => '24px',
						'position' => array(250, 420), // Position of the text - don't exceed 500,500!!
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#555'), // Want an outer line?
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'), // Want an inner line?
					'fill' => array('show' => true, 'rad' => array(200, 160),  'stroke_width' => 1, 'fill' => '#dee', 'border' => '#abb'), // A filled donought
				),
			),
		),
		'graygauge' => array(
			'name' => 'graygauge',
			'needle' => 'needle1',
			'dot' => 'normal',
			'background' => 'bg1',
			'part' => array(
				'split_up' => array(10, 5),
				'start_degree' => 225,
				'stop_degree' => 315,
				'inner_rad' => array(160, 170),
				'outer_rad' => array(200, 200),
				'stroke_width' => array(10, 2),
				'color' => array('#666', '#888'),
				'min_max' => array(0, 100),
				'text' => array(
					'show' => true,
					'font-size' => '14px',
					'rad' => 140,
					'color' => '#000',
					'rotate' => true,
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '26px',
						'position' => array(250, 330),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#555'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => true, 'rad' => array(200, 180),  'stroke_width' => 1, 'fill' => '#ddd', 'border' => '#ddd'),
				),
			),
		),
		'speedometer' => array(
			'name' => 'speedometer',
			'needle' => 'needle1',
			'dot' => 'normal',
			'background' => 'bg1',
			'part' => array(
				'split_up' => array(12, 5),
				'start_degree' => 270,
				'stop_degree' => 315,
				'inner_rad' => array(160, 180),
				'outer_rad' => array(200, 200),
				'stroke_width' => array(6, 2),
				'color' => array('#445', '#222'),
				'min_max' => array(0, 240),
				'text' => array(
					'show' => true,
					'font-size' => '14px',
					'rad' => 140,
					'color' => '#000',
					'rotate' => false,
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '24px',
						'position' => array(250, 330),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => true, 'rad' => 200, 'stroke_width' => 1, 'color' => '#333'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => true, 'rad' => array(200, 180),  'stroke_width' => 1, 'fill' => '#ddd', 'border' => '#ddd'),
				),
			),
		),
		'racer' => array(
			'name' => 'racer',
			'needle' => 'orange',
			'dot' => 'small_dot',
			'background' => 'halogen_racer',
			'part' => array(
				'split_up' => array(12, 5),
				'start_degree' => 270,
				'stop_degree' => 315,
				'inner_rad' => array(180, 190),
				'outer_rad' => array(200, 200),
				'stroke_width' => array(12, 6),
				'color' => array('#000', '#000'),
				'min_max' => array(0, 240),
				'text' => array(
					'show' => true,
					'font-size' => '14px',
					'font-family' => 'Arial, Helvetica, sans-serif',
					'font-weight' => 'bold',
					'rad' => 160,
					'color' => '#000',
					'rotate' => false,
					'offsetY' => '5',
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '22px',
						'position' => array(300, 370),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#333'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => false, 'rad' => array(200, 180),  'stroke_width' => 1, 'fill' => '#ddd', 'border' => '#ddd'),
				),
			),
		),
		'half' => array(
			'name' => 'half',
			'needle' => 'small_black',
			'dot' => 'small_black',
			'background' => 'bg1',
			'part' => array(
				'split_up' => array(4, 2),
				'start_degree' => 180,
				'stop_degree' => 0,
				'inner_rad' => array(170, 185),
				'outer_rad' => array(200, 200),
				'stroke_width' => array(8, 4),
				'color' => array('#666', '#666'),
				'min_max' => array(0, 100),
				'text' => array(
					'show' => true,
					'font-size' => '14px',
					'font-family' => 'Arial, Helvetica, sans-serif',
					'font-weight' => 'bold',
					'rad' => 150,
					'color' => '#000',
					'rotate' => false,
					'offsetY' => '5',
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '26px',
						'position' => array(250, 400),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#333'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => false, 'rad' => array(200, 180),  'stroke_width' => 1, 'fill' => '#ddd', 'border' => '#ddd'),
				),
			),
		),
		'radar' => array(
			'name' => 'radar',
			'needle' => 'needle1',
			'dot' => 'small_dot',
			'background' => 'bg1',
			'part' => array(
				'split_up' => array(10, 10),
				'start_degree' => 225,
				'stop_degree' => 315,
				'inner_rad' => array(30, 5),
				'outer_rad' => array(190, 190),
				'stroke_width' => array(5, 1),
				'color' => array('#444', '#888'),
				'min_max' => array(0, 100),
				'text' => array(
					'show' => true,
					'font-size' => '18px',
					'rad' => 210,
					'color' => '#000',
					'rotate' => false,
					'offsetY' => '5',
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '24px',
						'position' => array(250, 360),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => true, 'rad' => 190, 'stroke_width' => 2, 'color' => '#555'),
					'inner' => array('show' => true, 'rad' => 120,  'stroke_width' => 2, 'color' => '#aaa'),
					'fill' => array('show' => false, 'rad' => array(200, 160),  'stroke_width' => 1, 'fill' => '#dee', 'border' => '#abb'),
				),
			),
		),
		'blueglass' => array(
			'name' => 'blueglass',
			'needle' => 'needle1',
			'dot' => 'normal',
			'glass' => 'blue',
			'background' => 'bg1',
			'part' => array(
				'split_up' => array(10, 10),
				'start_degree' => 225,
				'stop_degree' => 315,
				'inner_rad' => array(160, 160),
				'outer_rad' => array(200, 200),
				'stroke_width' => array(5, 1),
				'color' => array('#666', '#888'),
				'min_max' => array(0, 100),
				'text' => array(
					'show' => true,
					'font-size' => '18px',
					'rad' => 140,
					'color' => '#000',
					'rotate' => false,
					'offsetY' => '5',
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '24px',
						'position' => array(250, 330),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#555'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => false, 'rad' => array(200, 160),  'stroke_width' => 1, 'fill' => '#dee', 'border' => '#abb'),
				),
			),
		),
		'temp' => array(
			'name' => 'temp',
			'needle' => 'small_black',
			'dot' => 'small_black',
			'background' => 'temperature',
			'part' => array(
				'split_up' => array(10, 10),
				'start_degree' => 225,
				'stop_degree' => 315,
				'inner_rad' => array(170, 170),
				'outer_rad' => array(205, 190),
				'stroke_width' => array(5, 1),
				'color' => array('#666', '#888'),
				'min_max' => array(0, 100),
				'text' => array(
					'show' => true,
					'font-size' => '18px',
					'rad' => 150,
					'color' => '#000',
					'rotate' => false,
					'offsetY' => '5',
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '26px',
						'position' => array(250, 400),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#555'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => false, 'rad' => array(200, 160),  'stroke_width' => 1, 'fill' => '#dee', 'border' => '#abb'),
				),
			),
		),
		'kungfu' => array(
			'name' => 'kungfu',
			'needle' => 'yellow',
			'dot' => 'small_gray',
			'background' => 'burning',
			'part' => array(
				'split_up' => array(10, 5),
				'start_degree' => 180,
				'stop_degree' => 270,
				'inner_rad' => array(180, 180),
				'outer_rad' => array(195, 195),
				'stroke_width' => array(5, 1),
				'color' => array('#eee', '#eee'),
				'min_max' => array(0, 100),
				'text' => array(
					'show' => true,
					'font-size' => '18px',
					'font-family' => 'Arial, Helvetica, sans-serif',
					'rad' => 220,
					'color' => '#fff',
					'rotate' => false,
					'offsetY' => '5',
					'description' => array(
						'show' => true,
						'color' => '#eee',
						'font-size' => '23px',
						'position' => array(170, 350),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#555'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => true, 'rad' => array(195, 180),  'stroke_width' => 2, 'fill' => '#333', 'border' => '#eee'),
				),
			),
		),
		'time' => array(
			'name' => 'time',
			'needle' => 'watch_minute',
			'dot' => 'small_gray',
			'background' => 'watch',
			'part' => array(
				'split_up' => array(3, 6),
				'start_degree' => 180, //  0 degree = right, 180 degree = left
				'stop_degree' => 270,
				'inner_rad' => array(200, 210),
				'outer_rad' => array(230, 230),
				'stroke_width' => array(16, 6),
				'color' => array('#333', '#444'),
				'min_max' => array(0, 180),
				'text' => array(
					'show' => true,
					'font-size' => '18px',
					'rad' => 170,
					'color' => '#000',
					'rotate' => false,
					'offsetY' => '5',
					'type' => 'time',
					'description' => array(
						'show' => true,
						'color' => '#000',
						'font-size' => '24px',
						'position' => array(160, 350),
						'text' => $gauge_desc <> '' ? $gauge_desc : '',
					),
				),
				'border' => array(
					'outer' => array('show' => false, 'rad' => 200, 'stroke_width' => 1, 'color' => '#555'),
					'inner' => array('show' => false, 'rad' => 180,  'stroke_width' => 3, 'color' => '#aaa'),
					'fill' => array('show' => false, 'rad' => array(200, 160),  'stroke_width' => 1, 'fill' => '#dee', 'border' => '#abb'),
				),
			),
		),
		// Your own definitions from here!
		
	);

	// Get the right style!
	$gauge_layout = $style_types[$style];

	// Create the layout
	$svg = get_layout($gauge_layout);


function get_layout($l)
{
	global $degrees, $set_val, $max_value;

	$bg_def = '';
	$bg = '';
	$glass = '';

	if ($max_value > 0)
	$l['part']['min_max'][1] = $max_value;


	// Create stripes
	$stripes = stripes($l['part']);

	// Turn the bloddy needle!
	$turn_needle = $l['part']['start_degree'] - ($set_val / $l['part']['min_max'][1] * $degrees);

	if ($l['background'] == 'bg1')
	{
		$bg_def .= '
<radialGradient id="id0" gradientUnits="userSpaceOnUse" cx="250" cy="250" r="250" fx="250" fy="250">
 <stop offset="0" stop-color="#FEFEFE"/>
 <stop offset="0.889608" stop-color="#000"/>
 <stop offset="0.901373" stop-color="#666666"/>
 <stop offset="0.940588" stop-color="white"/>
 <stop offset="0.948431" stop-color="white"/>
 <stop offset="0.979804" stop-color="gray"/>
 <stop offset="0.999412" stop-color="#000"/>
 <stop offset="1" stop-color="gray"/>
</radialGradient>

   <linearGradient id="id1" gradientUnits="userSpaceOnUse" x1="333.658" y1="478.725" x2="165.341" y2="16.2745">
 <stop offset="0" stop-color="#999999"/>
 <stop offset="0.368627" stop-color="#EDEDED"/>
 <stop offset="0.670588" stop-color="white"/>
 <stop offset="1" stop-color="#FEFEFE"/>
   </linearGradient>';
		$bg = '
<g id="Layer_x0020_2">
 <ellipse fill="url(#id0)" cx="250" cy="250" rx="250" ry="250" />
 <ellipse fill="url(#id1)" cx="250" cy="250" rx="224" ry="224" />
</g>';
	}
	else if ($l['background'] == 'halogen_racer')
	{
		$bg_def .= '
<radialGradient id="id0" gradientUnits="userSpaceOnUse" cx="250" cy="250" r="250" fx="250" fy="250">
 <stop offset="0" stop-color="#FEFEFE"/>
 <stop offset="0.889608" stop-color="#000"/>
 <stop offset="0.901373" stop-color="#666666"/>
 <stop offset="0.940588" stop-color="white"/>
 <stop offset="0.948431" stop-color="white"/>
 <stop offset="0.979804" stop-color="gray"/>
 <stop offset="0.999412" stop-color="#000"/>
 <stop offset="1" stop-color="gray"/>
</radialGradient>';

		$bg = '
<g id="Layer_x0020_2">
 <ellipse fill="#000" cx="250" cy="250" rx="250" ry="250" />
 <ellipse fill="#244" cx="250" cy="250" rx="245" ry="245" />
 <ellipse fill="#000" cx="250" cy="250" rx="230" ry="230" />
 <ellipse fill="#0ff" cx="250" cy="250" rx="224" ry="224" />
</g>';
	} else if ($l['background'] == 'temperature')
	{
		$bg .= '
<g id="Layer_x0020_2">
 <ellipse fill="#a5a5a5" cx="250" cy="250" rx="250" ry="250" />
 <ellipse fill="#c5c5c5" cx="250" cy="250" rx="245" ry="245" />
 <ellipse fill="#a5a5a5" cx="250" cy="250" rx="235" ry="235" />
 <ellipse fill="#f2f2f2" cx="250" cy="250" rx="230" ry="230" />
</g>';
	} else if ($l['background'] == 'burning')
	{
		$bg_def .= '
<radialGradient id="burning" gradientUnits="userSpaceOnUse" cx="250" cy="250" r="200" fx="350" fy="170">
 <stop offset="0" stop-color="yellow"/>
 <stop offset="0.4" stop-color="#f00"/>
 <stop offset="0.8" stop-color="#c00"/>
 <stop offset="0.9" stop-color="#a00"/>
 <stop offset="1" stop-color="#700"/>
</radialGradient>
<radialGradient id="darkgrey" gradientUnits="userSpaceOnUse" cx="250" cy="250" r="236" fx="236" fy="236">
 <stop offset="0.8" stop-color="#222"/>
 <stop offset="1" stop-color="#777"/>
</radialGradient>';
		$bg .= '
<g id="Layer_x0020_2">
 <ellipse fill="#999" cx="250" cy="250" rx="250" ry="250" stroke="#333" />
 <ellipse fill="#ccc" cx="250" cy="253" rx="238" ry="238" />
 <ellipse fill="url(#darkgrey)" cx="250" cy="250" rx="236" ry="236" stroke="#555" />
 <ellipse fill="url(#burning)" cx="250" cy="250" rx="200" ry="200" stroke="#222" />
</g>';
	} else if ($l['background'] == 'watch')
	{
		$bg .= '
<g id="Layer_x0020_2">
 <ellipse fill="#999" cx="250" cy="250" rx="250" ry="250" stroke="#333" />
 <ellipse fill="#ccc" cx="250" cy="253" rx="238" ry="238" />
 <ellipse fill="#f8f8f8" cx="250" cy="250" rx="236" ry="236" stroke="#555" />
</g>';
	}


// Needle definitions
	if ($l['needle'] == 'needle1')
	{
		$bg_def .= '
<linearGradient id="fill_needle" gradientUnits="userSpaceOnUse" x1="235" y1="250" x2="265" y2="250">
 <stop offset="0" stop-color="#600"/>
 <stop offset="0.5" stop-color="#f00"/>
 <stop offset="1" stop-color="#a00"/>
</linearGradient>';
		$needle = '
<polyline points="250,250 237,250 248,50 252,50 263,250" fill="url(#fill_needle)" stroke="#700" stroke-width="1" transform="rotate(' . (-$turn_needle + 90) . ' 250 250)" />';
	} else if ($l['needle'] == 'orange')
	{
		$bg_def .= '
<linearGradient id="fill_needle" gradientUnits="userSpaceOnUse" x1="235" y1="250" x2="265" y2="250">
 <stop offset="0" stop-color="#aa6600"/>
 <stop offset="0.5" stop-color="#ff7700"/>
 <stop offset="1" stop-color="#aa6600"/>
</linearGradient>';

		$needle = '
<polyline points="240,330 240,250 248,50 255,50 260,250 260,330 240,330" fill="url(#fill_needle)" stroke="#700" stroke-width="1" transform="rotate(' . (-$turn_needle + 90) . ' 250 250)" />';
	} else if ($l['needle'] == 'small_black')
	{
		$bg_def .= '
<linearGradient id="fill_needle" gradientUnits="userSpaceOnUse" x1="246" y1="250" x2="254" y2="250">
 <stop offset="0" stop-color="#000"/>
 <stop offset="0.5" stop-color="#777"/>
 <stop offset="1" stop-color="#000"/>
</linearGradient>';
		$needle = '
<polyline points="245,322 243,320 247,55 250,47 253,55 257,320 255,322 245,322" fill="url(#fill_needle)" stroke="none" stroke-width="1" transform="rotate(' . (-$turn_needle + 90) . ' 250 250)" />';
	} else if ($l['needle'] == 'yellow')
	{
		$bg_def .= '
<linearGradient id="fill_needle" gradientUnits="userSpaceOnUse" x1="235" y1="250" x2="265" y2="250">
 <stop offset="0" stop-color="#ee0"/>
 <stop offset="0.5" stop-color="#ff0"/>
 <stop offset="1" stop-color="#ee0"/>
</linearGradient>';
		$needle = '
<polyline points="243,250 243,70 250,55 257,70 257,250 243,250" fill="url(#fill_needle)" stroke="#700" stroke-width="1" transform="rotate(' . (-$turn_needle + 90) . ' 250 250)" />';
	} else if ($l['needle'] == 'watch_minute')
	{
		$needle = '
<polyline points="244,310 247,22 253,22 256,310 244,310" fill="#333" stroke="none" transform="rotate(' . (-$turn_needle + 90) . ' 250 250)" />';
	}
// END Needles


// Middle dot
	if ($l['dot'] == 'normal')
	{
		$dot = '
<ellipse id="dot_middle" fill="url(#fill_black_dot)" cx="250" cy="250" rx="37" ry="37" />';
		$bg_def .= '
<radialGradient id="fill_black_dot" gradientUnits="userSpaceOnUse" cx="250" cy="245" r="24" fx="250" fy="245">
 <stop offset="0" stop-color="#4F4F4F"/>
 <stop offset="0.329412" stop-color="#444444"/>
 <stop offset="0.560784" stop-color="#2D2D2D"/>
 <stop offset="0.65098" stop-color="#1E1E1E"/>
 <stop offset="0.721569" stop-color="#141414"/>
 <stop offset="0.788235" stop-color="#0D0D0D"/>
 <stop offset="0.858824" stop-color="#070707"/>
 <stop offset="0.929412" stop-color="#030303"/>
 <stop offset="1" stop-color="#000"/>
</radialGradient>';
	}else if ($l['dot'] == 'small_dot')
	{
		$dot = '
<ellipse id="dot_middle" fill="url(#fill_black_dot)" cx="250" cy="250" rx="19" ry="19" />';
		$bg_def .= '
<radialGradient id="fill_black_dot" gradientUnits="userSpaceOnUse" cx="250" cy="245" r="19" fx="250" fy="245">
 <stop offset="0" stop-color="#4F9999"/>
 <stop offset="0.329412" stop-color="#444444"/>
 <stop offset="0.560784" stop-color="#2D2D2D"/>
 <stop offset="0.65098" stop-color="#1E1E1E"/>
 <stop offset="0.721569" stop-color="#141414"/>
 <stop offset="0.788235" stop-color="#0D0D0D"/>
 <stop offset="0.858824" stop-color="#070707"/>
 <stop offset="0.929412" stop-color="#030303"/>
 <stop offset="1" stop-color="#000"/>
</radialGradient>';
	} else if ($l['dot'] == 'small_black')
	{
		$dot = '
<ellipse id="dot_middle" fill="#000" cx="250" cy="250" rx="25" ry="25" />
<ellipse id="dot_middle" fill="#262626" cx="250" cy="250" rx="19" ry="19" />';
	} else if ($l['dot'] == 'small_gray')
	{
		$dot = '
<ellipse id="dot_middle" fill="#777" cx="250" cy="250" rx="25" ry="25" />
<ellipse id="dot_middle" fill="#999" cx="250" cy="250" rx="19" ry="19" stroke="#666" />';
	}

// Glass effect definitions
	if (isset($l['glass']) && $l['glass'] == 'blue')
	{
		$bg_def .= '
<radialGradient id="glass" gradientUnits="userSpaceOnUse" cx="250" cy="250" r="224" fx="190" fy="140">
 <stop offset="0" stop-color="#fff"/>
 <stop offset="0.1" stop-color="#aaf"/>
 <stop offset="0.3" stop-color="#99f"/>
 <stop offset="0.6" stop-color="#00f"/>
 <stop offset="0.8" stop-color="#005"/>
 <stop offset="1" stop-color="#003"/>
</radialGradient>';
		$glass = '
<ellipse id="dot_middle" fill="url(#glass)" cx="250" cy="250" rx="224" ry="224" fill-opacity="0.3" />';
	}
// END Glass effect definitions

// General Styling
		$styling = '
<style type="text/css">
<![CDATA[
.numbers
{
	text-anchor:middle;
	alignment-baseline:central;
	'. (isset($l['part']['text']['font-family']) && $l['part']['text']['font-family'] <> '' ? ' font-family:' . $l['part']['text']['font-family'] . ';' : '') . '
	'. (isset($l['part']['text']['font-weight']) && $l['part']['text']['font-weight'] <> '' ? ' font-weight:' . $l['part']['text']['font-weight'] . ';' : '') . '
	'. ($l['part']['text']['font-size'] <> '' ? ' font-size:' . $l['part']['text']['font-size'] . ';' : '') . '
	'. ($l['part']['text']['color'] <> '' ? ' fill:' . $l['part']['text']['color'] . ';' : '') . '
}
]]>
</style>';
// END General Styling


	$final_layout = '
<defs>' . $styling . $bg_def . '
</defs>' . $bg . $stripes . $needle . $dot . $glass;

	return $final_layout;
}


function stripes($striping)
{
	global $degrees;

	$result = '';
	$degrees = $striping['stop_degree'] > $striping['start_degree'] ? 360 - $striping['stop_degree'] + $striping['start_degree'] : ($striping['stop_degree'] - $striping['start_degree'] < 0 ? $striping['start_degree'] - $striping['stop_degree'] : $striping['stop_degree'] - $striping['start_degree']);
	$part_degree = $degrees / $striping['split_up'][0];

	if ($striping['border']['fill']['show'] === true)
	{
		$stripe1_start = calc_it($striping['start_degree'], $striping['border']['fill']['rad'][0], false);
		$stripe1_end = calc_it($striping['stop_degree'], $striping['border']['fill']['rad'][0], false);
		$stripe2_start = calc_it($striping['start_degree'], $striping['border']['fill']['rad'][1], false);
		$stripe2_end = calc_it($striping['stop_degree'], $striping['border']['fill']['rad'][1], false);

		$result .= '
<path d="M' . $stripe1_start['h'] . ',' . $stripe1_start['v'] . ' a' . $striping['border']['fill']['rad'][0] . ',' . $striping['border']['fill']['rad'][0] . ' 1 ' . ($degrees > 180 ? 1 : 0) . ',1 ' . ($stripe1_end['h'] - $stripe1_start['h']) . ',' . ($stripe1_end['v'] - $stripe1_start['v']) . ' l' . ($stripe2_end['h'] - $stripe1_end['h']) . ',' . ($stripe2_end['v'] - $stripe1_end['v'])

 . ' a' . $striping['border']['fill']['rad'][1] . ',' . $striping['border']['fill']['rad'][1] . ' 1 ' . ($degrees > 180 ? 1 : 0) . ',0 ' . ($stripe2_start['h'] - $stripe2_end['h']) . ',' . ($stripe2_start['v'] - $stripe2_end['v']) . ' . "
fill="' . $striping['border']['fill']['fill'] . '" stroke="' . $striping['border']['fill']['border'] . '" stroke-width="' . $striping['border']['fill']['stroke_width'] . '" />';
	}


	// Outer border!
	if ($striping['border']['outer']['show'] === true)
	{
		$stripe_start = calc_it($striping['start_degree'], $striping['border']['outer']['rad'], false);
		$stripe_end = calc_it($striping['stop_degree'], $striping['border']['outer']['rad'], false);

		$result .= '
<path d="M' . $stripe_start['h'] . ',' . $stripe_start['v'] . ' a' . $striping['border']['outer']['rad'] . ',' . $striping['border']['outer']['rad'] . ' 1 ' . ($degrees > 180 ? 1 : 0) . ',1 ' . ($stripe_end['h'] - $stripe_start['h']) . ',' . ($stripe_end['v'] - $stripe_start['v']) . '"
fill="none" stroke="' . $striping['border']['outer']['color'] . '" stroke-width="' . $striping['border']['outer']['stroke_width'] . '" />';
	}

	if ($striping['border']['inner']['show'] === true)
	{
		$stripe_start = calc_it($striping['start_degree'], $striping['border']['inner']['rad'], false);
		$stripe_end = calc_it($striping['stop_degree'], $striping['border']['inner']['rad'], false);

		$result .= '
<path d="M' . $stripe_start['h'] . ',' . $stripe_start['v'] . ' a' . $striping['border']['inner']['rad'] . ',' . $striping['border']['inner']['rad'] . ' 1 ' . ($degrees > 180 ? 1 : 0) . ',1 ' . ($stripe_end['h'] - $stripe_start['h']) . ',' . ($stripe_end['v'] - $stripe_start['v']) . '"
fill="none" stroke="' . $striping['border']['inner']['color'] . '" stroke-width="' . $striping['border']['inner']['stroke_width'] . '" />';
	}


	$degree = 0;
	for ($x = 0; $x <= $striping['split_up'][0]; $x++)
	{
		$degree = $degrees / $striping['split_up'][0] * $x;
		$turn = $striping['start_degree'] - $degree;
		$stripe_start = calc_it($turn, $striping['outer_rad'][0], false);
		$stripe_end = calc_it($turn, $striping['inner_rad'][0], false);

		$result .= '
<line class="split" x1="' . $stripe_start['h'] . '"		y1="' . $stripe_start['v'] . '" x2="' . $stripe_end['h'] . '" y2="' . $stripe_end['v'] . '" stroke="' . $striping['color'][0] . '" stroke-width="' . $striping['stroke_width'][0] . '" />';

		if ($striping['split_up'][1] > 0 && $x < $striping['split_up'][0])
		{
			for ($x2 = 1; $x2 < $striping['split_up'][1]; $x2++)
			{
				$split_degree = $part_degree / ($striping['split_up'][1]);
				$turn2 = $turn - ($split_degree * $x2);
				$stripe_start = calc_it($turn2, $striping['outer_rad'][1], false);
				$stripe_end = calc_it($turn2, $striping['inner_rad'][1], false);
			
				$result .= '
<line class="small_split" x1="' . $stripe_start['h'] . '"		y1="' . $stripe_start['v'] . '" x2="' . $stripe_end['h'] . '" y2="' . $stripe_end['v'] . '" stroke="' . $striping['color'][1] . '" stroke-width="' . $striping['stroke_width'][1] . '" />';
			}
		}
		if ($striping['text']['show'] === true)
		{
			$gauge_v = $part_degree / $degrees * $x * $striping['min_max'][1];
			$stripe_start = calc_it($turn, $striping['text']['rad'], false);
			$stripe_start['v'] = isset($striping['text']['offsetY']) && $striping['text']['offsetY'] > 0 ? $stripe_start['v'] + $striping['text']['offsetY'] : $stripe_start['v'];
			$result .= '
	<g class="number_container">
		<text class="numbers"' . ($striping['text']['rotate'] === true ? ' transform="rotate(' . (-$turn + 90) . ' ' . $stripe_start['h'] . ' ' . $stripe_start['v'] . ')"' : '') . ' x="' . $stripe_start['h'] . '" y="' . $stripe_start['v'] . '">' . (isset($striping['text']['type']) ? ($striping['text']['type'] == 'time' ? ($gauge_v / 60) . ':00' : '') : round($gauge_v,2)) . '</text>
	</g>';
		}

	}
	$result .= $striping['text']['description']['show'] === true ? '
		<text class="description" x="' . $striping['text']['description']['position'][0] . '" y="' . $striping['text']['description']['position'][1] . '" text-anchor="middle" font-size="' . $striping['text']['description']['font-size'] . '" fill="' . $striping['text']['description']['color'] . '"' . (isset($striping['text']['font-family']) ? ' font-family="' . $striping['text']['font-family'] . '"' : '') . '>' . $striping['text']['description']['text'] . '</text>' : '';
	return $result;
}

function calc_it($degree, $radius, $inv = false)
{
	global $centerX, $centerY;

	$height = round($radius * sin(deg2rad($degree)), 5);
	$height = -$height; // Blody coordinates are from top to down, so reverse the value!
	$height = $height + $centerY;

	$width = round($radius * cos(deg2rad($degree)), 5);
	$width = $width + $centerX;

	$result = array('D' => $degree, 'h' => $width, 'v' => $height);
	return $result;
}


	$svg_start =
'<?xml version="1.0" standalone="no"?>
<?xml-stylesheet href="css/pie.css" type="text/css"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" 
  "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">

<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="500px" height="500px" viewBox="0 0 500 500">';

	$svg_end = '</svg>';

	function microtime_float()
	{
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
	}
	echo $svg_start . $svg . $svg_end;

	$time_end = microtime_float(true);
	$time = round($time_end - $time_start, 5);
	echo '
	<!-- Created by Akyhne\'s Simple Chart Gauge script in ' . $time . ' seconds -->';

?>