<?php
/*******************************************************************************
* Simple Chart © By Akyhne													   *
********************************************************************************
* SimplePie.php V 0.5												   *
********************************************************************************/


	// Without this, all browsers except IE9+ will not accept external svg stylesheets!
	header('Content-type: image/svg+xml; charset=UTF-8');
	$time_start = microtime_float(true);
	$chart = $_GET['data'];
	$chart = gzuncompress(base64_decode($chart));
	$max = isset($_GET['max']) ? $_GET['max'] : 0;
	$chart_list = preg_split('/[|]/', $chart, -1, PREG_SPLIT_NO_EMPTY);
	$chart_columns = count($chart_list);
	foreach ($chart_list as $list)
	{
		$list_values = explode(':::', $list);
		// Split and limit to 50 columns!
		$chart_chart[$list_values[0]] = explode(";", $list_values[1], 50);
	}

	// Some general settings
	$chart_width = 630;
	$chart_height = 420;
	$pie_rad = 150; // radius on pies
	$offsetX = 200; // Pie offset
	$offsetY = round($chart_height / 2, 0);
	$text_offsetX = 430;
	$text_offsetX_additionalText = 210;
	$line_height = 20;
	$text_offsetY = $offsetY - ($chart_columns > 20 ? (20 * $line_height / 2) : ($chart_columns * $line_height / 2));
	$text_offsetY_startNew = $text_offsetY;
	$fontSize = 14;
	$colors = array('green', 'blue', 'yellow', 'brown', 'red', '#0cf', '#ffc0cb', '#33ff66', '#fc0', '#ff0080', '#1a18a1', '#b0f', '#c8d607', '#f80', '#cf9d9d', '#dedede', '#002e8a', '#f3ff99', '#999', '#bf8282', '#8f8fa6', '#e6e6eb', '#a1cca1', '#e3caba', '#dbb3db');
	$svg = '';

	$sum = 0;
	foreach ($chart_chart as $key => $val)
	{
		foreach ($val as $val2)
			$sum = $sum + (float)$val2;
	}
	$sum = $max > $sum ? $max : $sum;
	$coordinates = array();
	$last_deg = 0;
	$new_deg = 0;
	
	$turn = 45;
	foreach ($chart_chart as $key => $val)
	{
		foreach ($val as $val2)
		{
			$new_deg = round(360 / $sum * $val2, 1) + $last_deg;
			$coordinates[] = array($last_deg, $new_deg);
			$last_deg = $new_deg;
			$chart_keys[] = array($key, $val2, round($val2 / $sum * 100, 1));
		}
	}

	$c = 0;
	foreach ($coordinates as $key => $cake)
	{
		$coord = array();
		$text_deg = round($cake[0] + ($cake[1] - $cake[0]) / 2, 1);
		for ($i = 0; $i < 2; $i++)
		{
			$val = $cake[$i];
			$coord[] = calc_it($val, $pie_rad, $i == 0 ? true : false);
		}

		$text_coord = calc_it($text_deg, $pie_rad + 16, false);

		if ($text_coord['h'] > 0)
			$text_coord['h'] = $text_coord['h'] + round($text_coord['h'] / $pie_rad * 10, 2);
		else
			$text_coord['h'] = $text_coord['h'] + round($text_coord['h'] / $pie_rad * 10, 2);

		$arc_pos_h = $coord[0]['h'] + $coord[1]['h'];
		$arc_pos_h = -$arc_pos_h;
		$arc_pos_v = $coord[0]['v'] + $coord[1]['v'];
		$arc_pos_v = -$arc_pos_v;
		$svg .= '
		<svg onmouseover="Highlight(evt, \'cake' . $c . '\', \'text_bg' . $c . '\');" onmouseout="Unhighlight(evt, \'cake' . $c . '\', \'text_bg' . $c . '\');">
			<path id="cake' . $c . '" d="M' . ($offsetX - $coord[1]['h']) . ',' . ($offsetY - $coord[1]['v']) . ' l ' . $coord[1]['h'] . ',' . $coord[1]['v'] . ' ' . $coord[0]['h'] . ',' . $coord[0]['v'] . ' a' . $pie_rad . ',' . $pie_rad . ' 0 ' . ($cake[1] - $cake[0] > 180 || $cake[1] - $cake[0] < - 0 ? 1 : 0) . ',1 ' . $arc_pos_h. ',' . $arc_pos_v. '" fill="' . $colors[$c] . '" stroke="white" stroke-width="1" />
		</svg>
			<text style="text-anchor:middle" text-anchor="start" x="' . ($offsetX - $text_coord['h']) . '" y="' . ($offsetY - $text_coord['v'] + 5) . '" font-family="Arial" font-size="14" stroke="none" stroke-width="0" fill="#222222">' . $chart_keys[$c][2] . '&#37;</text>
';

		$tl = strlen($chart_keys[$c][0]);
		if ($tl > 32)
			$fontSizeFinal = round($fontSize * 0.6);
		else if ($tl > 25)
			$fontSizeFinal = round($fontSize * 0.67);
		else if ($tl > 20)
			$fontSizeFinal = round($fontSize * 0.8);
		else
			$fontSizeFinal = $fontSize;
		
		$svg .= '
		<g class="text_holder" onmouseover="Highlight(evt, \'cake' . $c . '\', \'text_bg' . $c . '\');" onmouseout="Unhighlight(evt, \'cake' . $c . '\', \'text_bg' . $c . '\');">
			<rect id="text_bg' . $c . '" x="' . $text_offsetX . '" y="' . $text_offsetY . '" width="198" height="' . $line_height . '" stroke="none" stroke-width="0" fill-opacity="0" fill="#ccd"/>
				<text text-anchor="start" x="' . ($text_offsetX + 24) . '" y="' . ($text_offsetY +13) . '" font-family="Arial" font-size="' . $fontSizeFinal . '" stroke="none" stroke-width="0" fill="#222222">' . $chart_keys[$c][0] . ' (' . $chart_keys[$c][1] . ')</text>
			<rect id="cake' . $c . '_box" x="' . $text_offsetX . '" y="' . $text_offsetY . '" width="14" height="14" stroke="none" stroke-width="0" fill="' . $colors[$c] . '"/>
		</g>
';

		// More than 1 column of text?
		if ($c == 19 || $c == 39)
		{
			$text_offsetY = $text_offsetY_startNew;
			$text_offsetX = $text_offsetX + $text_offsetX_additionalText;
			$chart_width = $chart_width + $text_offsetX_additionalText;
		}
		else
			$text_offsetY = $text_offsetY + $line_height;

		unset($coord);unset($text_coord);
		$c++;
	}

	$svg_start = '<?xml version="1.0" standalone="no"?>
<?xml-stylesheet href="css/pie.css" type="text/css"?>
<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" 
  "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="' . $chart_width . '" height="' . $chart_height . 'px" viewBox="0 0 ' . $chart_width . ' ' . $chart_height . '">
	<rect class="pie_background" x="1" y="1" width="' . ($chart_width - 2) . '" height="' . ($chart_height - 2) . '" fill="none" />
  <defs>
    <filter id="dropshadow" height="130%">
      <feGaussianBlur in="SourceAlpha" stdDeviation="3"/> 
      <feOffset dx="2" dy="2" result="offsetblur"/>
	  <feComponentTransfer>
        <feFuncA type="linear" slope="0.4"/>
      </feComponentTransfer>
      <feMerge> 
        <feMergeNode/>
        <feMergeNode in="SourceGraphic"/> 
      </feMerge>
    </filter>
  </defs>

<script>
<![CDATA[

	function Unhighlight(evt, what, bg)
	{
		var tbg = evt.target.ownerDocument.getElementById(bg);
		tbg.setAttribute("fill-opacity", "0");
		var t = evt.target.ownerDocument.getElementById(what);
		t.setAttribute("stroke", "white");
		t.setAttribute("transform", "scale(1)");
		t.setAttribute("filter", "none");
	}
	function Highlight(evt, what, bg)
	{
		var tbg = evt.target.ownerDocument.getElementById(bg);
		tbg.setAttribute("fill-opacity", "1");
		var t = evt.target.ownerDocument.getElementById(what);
		t.setAttribute("stroke", "#333");
		t.setAttribute("transform", "translate(-9, -10) scale(1.05)");
		t.ownerSVGElement.appendChild(t);
		t.setAttribute("filter", "url(#dropshadow)");
	}
	function HitMe(evt, what)
	{
		alert("Hit me! " + what);
	}
]]>
</script> ';

	$svg_end = '
		</svg>';
	// Output everything
	echo $svg_start . $svg . $svg_end;

function microtime_float()
{
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

	$time_end = microtime_float(true);
	$time = round($time_end - $time_start, 5);
	echo '
	<!-- Created by Akyhne\'s Simple Chart Pie script in ' . $time . ' seconds -->';


function calc_it($val, $pie_rad, $inv = false)
{
	if ($inv !== false)
		$pie_rad = -$pie_rad;
	$height = round($pie_rad * cos(deg2rad($val)), 1);
	$width = round($pie_rad * sin(deg2rad($val)), 1);
	$result = array('D' => $val, 'h' => $height, 'v' => $width);
	return $result;
}
?>