<?php
/*******************************************************************************
* Simple Chart © By Akyhne													   *
********************************************************************************
* Subs-SimpleChart.php V 0.5												   *
********************************************************************************/




if (!defined('SMF'))
	die('Hacking attempt...');

// Chart tag	
function akyhne_simplechart_tag(&$codes)
{
	global $modSettings, $txt;

	$codes[] = 	array(
				'tag' => 'chart',
				'type' => 'unparsed_content',
				'parameters' => array(
					'width' => array('optional' => true, 'value' => ' style="width:$1px;"', 'match' => '(\d+)'),
					'height' => array('optional' => true, 'value' => ' height="$1"', 'match' => '(\d+)'),
					'title' => array('optional' => true, 'quoted' => true, 'value' => '<div class="chart_title">$1</div>'),
					'align' => array('optional' => true, 'value' => 'float:$1', 'match' => '(none|right|left|center)'),
					'layout' => array('optional' => true),
					'style' => array('optional' => true, 'value' => ' $1'),
					'max' => array('optional' => true, 'value' => '$1', 'match' => '(\d+)'),
				),
				'content' => '
					<div class="chart_container{style}">
						<ul class="chart_inner"><li style="{align}">{title}&nbsp;
						<table class="chart_table">
							$1
						</table>
					</li></ul></div>
					<br class="clear" />',
				'before' => '{width}\'{height}\'' . htmlspecialchars('{title}') . '\'{align}\'{layout}\'{style}\'{max}', // Cheating a bit to get parameter values to the validate function :)
				'validate' => create_function('&$tag, &$data, $disabled', '
					global $txt;
					loadLanguage(\'SimpleChart\');

					$chart = $data;
					$chart_tags = array("width", "height", "title", "align", "layout", "style", "max");
					$params = explode(\'\\\'\', $tag[\'before\']);
					$params = array_combine($chart_tags, $params);
					
					preg_match(\'/(\d+)/\', $params["width"], $matches);
					$chart_width = isset($matches[0]) && intval($matches[0]) > 79 && intval($matches[0]) < 1000 ? intval($matches[0]) : ($params["layout"] == \'gauge\' ? 300 : 500);
					preg_match(\'/(\d+)/\', $params["height"], $matches);
					$chart_height = isset($matches[0]) && intval($matches[0]) > 79 && intval($matches[0]) < 1000 ? intval($matches[0]) : ($params["layout"] == \'gauge\' ? 300 : 300);
					$chart_align = $params["align"] == \'\' ? \'none\' : $params["align"];
					preg_match(\'/(\d+)/\', $params["max"], $matches);
					$chart_ceil = isset($matches[0]) && $matches[0] > 0 ? $matches[0] : 0;
					$params["style"] = trim($params["style"]);
					
					// Layout.. vertical, horisontal, pie, gauge... whatever...
					$params["layout"] = $params["layout"] == \'v\' || $params["layout"] == \'h\' || $params["layout"] == \'pie\' || $params["layout"] == \'gauge\' || $params["layout"] == \'stars\' ? $params["layout"] : \'h\';
					
					$chart_list = preg_split(\'/[|]/\', $chart, -1, PREG_SPLIT_NO_EMPTY);
					$chart_columns = count($chart_list);
					foreach ($chart_list as $list)
					{
						$list_values = preg_split(\'/[=]/\', $list, -1, PREG_SPLIT_NO_EMPTY);
						// Split and limit to 50 columns!
						if (is_array($list_values) && count($list_values) > 1)
							$chart_chart[$list_values[0]] = explode(";", $list_values[1], 50);
					}
					$no_of_values = isset($chart_chart) ? count($chart_chart, COUNT_RECURSIVE) - count($chart_list) : 0;

					$array_length = 0;
					if (isset($chart_chart) && is_array($chart_chart))
					{
						// Finding the longest level in multi level charts
						foreach($chart_chart as $key => $val)
						{
							if ($array_length < count($val))
								$array_length = count($val);
						}

						// Find the biggest value
						$highest = (float)0;
						foreach($chart_chart as $key => $val)
						{
							foreach($val as $val2)
							{
								$thisV = floatval(str_replace(",", ".", $val2));
								if ($thisV > $highest)
									$highest = $thisV;
							}
						}
						$highest = $chart_ceil > $highest ? $chart_ceil : $highest;
					}

					$MyChart_columns = \'\';
					$MyChart_rows = \'\';
					$MyChart_names = \'\';

					// Pie Chart
					if ($params["layout"] == \'pie\')
					{
						$MyChart = simplechart_pie($chart, $chart_ceil, $no_of_values);
					}
					// Gauge Chart
					else if ($params["layout"] == \'gauge\')
					{
						$patterns = array(\'/<table class="chart_table">/\', \'/<\/table>/\', \'/chart_container/\');
						$replace = array(\'\', \'\', \'chart_container_gauge\');
						$tag[\'content\'] = preg_replace($patterns, $replace, $tag[\'content\']);
						$MyChart = simplechart_gauge($chart, $chart_width, $chart_ceil, $params);
					}
					// Stars layout
					else if ($params["layout"] == \'stars\')
					{
						$patterns = array(\'/<ul class="chart_inner"><li style="">/\', \'/<\/li><\/ul>/\', \'/chart_container/\', \'/<br class="clear" \/>/\');
						$replace = array(\'\', \'\', \'chart_container_stars\', \'\');
						$tag[\'content\'] = preg_replace($patterns, $replace, $tag[\'content\']);
						$MyChart = simplechart_stars($chart, $chart_ceil, $params);
					}

					// Multi level chart
					else if ($array_length > 1)
					{
						$column_width = round($chart_width / ($no_of_values + count($chart_chart) - 1));
						$w = 0;
						foreach($chart_chart as $key => $val)
						{
							$w++;
							$x = 0;
							foreach($val as $val2)
							{
								$val3 = str_replace(",", ".", $val2);
								if ($params["layout"] == \'v\')
								{
									$x++;
									$col_height = ceil($chart_height / $highest * $val3);
									$MyChart_columns .= \'
							<td class="chart_column" style="width:\' . $column_width . \'px; height:\'. $chart_height. \'px">\' . ($col_height < 21 ? \'<span class="col_val_outside">\' . $val2 . \'</span>\' : \'\') . \'<div class="chart_values chart_value_\' . $x . \'" style="width:70%; height:\'. $col_height. \'px">\' . ($col_height > 20 ? \'<span class="col_val_outside">\' . $val2 . \'</span>\' : \'\') . \'</div></td>\';

									if ($x == count($val) && $w < count($chart_chart))
										$MyChart_columns .= \'<td class="chart_column" style="width:\' . $column_width . \'px">&nbsp;</td>\';

									if ($x == 1)
										$MyChart_names .= \'<td colspan="\' . ($w !== count($chart_chart) ? count($val) + 1 : count($val)) . \'"><div class="col_title">\' . $key . \'</div></td>\';
								} else
								{
									$x++;
									$val_width = strlen($val2) * 10 + 10;
									$col_width = ceil($chart_width / $highest * $val2);
									
									if ($x == 1) //if ($x == count($val) && $w < count($chart_chart))
									$MyChart_rows .= \'
							<tr><td class="chart_key" rowspan="\' . ($w !== count($chart_chart) ? count($val) + 1 : count($val)) . \'">\' . $key . \'</td>\';

									$MyChart_rows .= \'
							\' . ($x == 1 ? \'\' : \'<tr>\') . \'<td class="chart_row" style="width:\' . $chart_width . \'px"><div class="chart_values chart_value_\' . $x . \'" style="width:\' . $col_width . \'px">\' . ($col_width > $val_width + 1 ? \'<span class="row_val">\' . $val2 . \'</span>\' : \'&nbsp;\') . \'</div>\' . ($col_width < $val_width ? \'<span class="row_val">\' . $val2 . \'</span>\' : \'\') . \'</td></tr>\';

									if ($x == count($val) && $w < count($chart_chart))
									$MyChart_rows .= \'
							<tr><td class="chart_row chart_divider" style="width:\' . $chart_width . \'px">&nbsp;</td></tr>\';
								}
							}
						}
						if ($params["layout"] == \'v\')
							$MyChart = \'<tr>\' . $MyChart_columns . \'</tr><tr>\' . $MyChart_names . \'
						</tr>\';
						else
							$MyChart = $MyChart_rows;
					}
					// Single level chart
					elseif ($array_length == 1)
					{
						$column_width = round($chart_width / $chart_columns);
						foreach($chart_chart as $key => $val)
						{
							foreach($val as $val2)
							{
								$val3 = str_replace(",", ".", $val2);
								if ($params["layout"] == \'v\')
								{
									$col_height = ceil($chart_height / $highest * $val3);
									$MyChart_columns .= \'
							<td class="chart_column" style="width:\' . $column_width . \'px; height:\'. $chart_height. \'px">\' . ($col_height < 21 ? \'<span class="col_val_outside">\' . $val2 . \'</span>\' : \'\') . \'<div class="chart_values chart_value_1" style="width:70%; height:\'. $col_height. \'px">\' . ($col_height > 20 ? \'<span class="col_val">\' . $val2 . \'</span>\' : \'\') . \'</div></td>\';
									$MyChart_names .= \'<td><div class="col_title">\' . $key . \'</div></td>\';
								} else
								{
									$val_width = strlen($val2) * 10 + 10;
									$col_width = ceil($chart_width / $highest * $val2);
									$MyChart_rows .= \'
							<tr><td class="chart_key">\' . $key . \'</td><td class="chart_row" style="width:\' . $chart_width . \'px"><div class="chart_values chart_value_1" style="width:\' . $col_width . \'px">\' . ($col_width > $val_width + 1 ? \'<span class="row_val">\' . $val2 . \'</span>\' : \'&nbsp;\') . \'</div>\' . ($col_width < $val_width ? \'<span class="row_val">\' . $val2 . \'</span>\' : \'\') . \'</td></tr>\';
								}
							}
							if ($params["layout"] == \'v\')
								$MyChart = \'<tr>\' . $MyChart_columns . \'</tr><tr>\' . $MyChart_names . \'
						</tr>\';
							else
								$MyChart = $MyChart_rows;
						}
						
					} else {
						$MyChart = $txt[\'simple_chart_missing_values\'];
					}
					$data = $MyChart;
				'),
				'disabled_content' => '($1)',
			);

}

function simplechart_pie($chart, $chart_ceil, $no_of_values)
{
	global $boardurl;

	$pie_data = urlencode(base64_encode(gzcompress(str_replace("=", ":::", $chart))));				
	$MyChart = '<tr><td>
	<object' . ($no_of_values > 40 ? ' width="1050px"' : ($no_of_values > 20 ? ' width="840px"' : ' width="630px"')) . ' height="430px" class="pie_object" data="' . $boardurl . '/Simple_Chart/SimplePie.php?data=' . $pie_data . '&amp;max=' . $chart_ceil . '" ></object>
	</td></tr>';
	
	return $MyChart;
}


function simplechart_gauge($chart, $chart_width, $chart_ceil, $params)
{
	
	global $boardurl;

	$chart_height = $chart_width;
	$gauge_data = urlencode(str_replace("=", ":::", $chart));

	$MyChart = '
	<img src="' . $boardurl . '/Simple_Chart/SimpleGauge.php?data=' . $gauge_data . '&amp;max=' . $chart_ceil . '&amp;style=' . $params["style"] . '" alt="" width="' . $chart_width . '" height="'. $chart_height. '" />';

	return $MyChart;
}


function simplechart_stars($chart, $chart_ceil, $params)
{
	
	global $boardurl, $boarddir;

	if ($params["style"] !== '' && file_exists($boarddir . '/Simple_Chart/images/stars/' . $params["style"]))
		$path = $params["style"];
	else
		$path =  'default';

	$chart = str_replace(",", ".", $chart);
	preg_match('~\d+(?:\.\d+)?~', $chart, $matches);
	$float_val = isset($matches[0]) ? round((float)$matches[0], 1) : 0;
	//$chart;
	$chart_ceil = $chart_ceil > 20 ? 20 : ($chart_ceil == 0 || $chart_ceil == '' ? 10 : (int)$chart_ceil);
	if ($float_val > $chart_ceil)
		$float_val = $chart_ceil;

	$star = explode('.', $float_val);

	$MyChart = '<tr>';
	

	for ($i = 1; $i < $chart_ceil + 1; $i++)
	{
		//$MyChart .= '<td>' . '</td>';
		if ($i > $star[0])
			$MyChart .= '<td><img src="' . $boardurl . '/Simple_Chart/images/stars/' . $path . '/0.png" alt="" /></td>';
		else
		if ($i <= $star[0])
		{
			$MyChart .= '<td><img src="' . $boardurl . '/Simple_Chart/images/stars/' . $path . '/1.png" alt="" /></td>';
			if ($i == $star[0] && count($star) == 2)
			{
				$MyChart .= '<td><img src="' . $boardurl . '/Simple_Chart/images/stars/' . $path . '/0.' . $star[1] . '.png" alt="" /></td>';
				$i++;
			}
		}
	}
	$MyChart .= '</tr>';

	//$MyChart .= '<tr><td colspan="' . $chart_ceil . '">' . $float_val . ' ' . $chart_ceil . '</td></tr>';
	return $MyChart;
}

function akyhne_simplechart_load_theme()
{
	global $txt, $modSettings, $context, $settings;
	
	//loadLanguage('Highlight');
	if (file_exists($settings['theme_url'] . '/css/simplechart.css'))
		$context['html_headers'] .= '
	<link rel="stylesheet" type="text/css" href="' . $settings['theme_url'] . '/css/simplechart.css" />';
	else
		$context['html_headers'] .= '
	<link rel="stylesheet" type="text/css" href="' . $settings['default_theme_url'] . '/css/simplechart.css" />';

}

// Add the BBC button in the editor
function akyhne_simplechart_button()
{
	 global $txt, $context;

	loadLanguage('SimpleChart');

	 $context['bbc_tags'][count($context['bbc_tags']) - 1][] = array(
		 'image' => 'chart',
		 'code' => 'chart',
		 'before' => '[chart]',
		 'after' => '[/chart]',
		 'description' => $txt['bbc_chart']
	 );

}

// Add the BBC help button in the editor (needs a mod to be activated!)
function akyhne_simplechart_help_button()
{
	 global $txt, $context;

	loadLanguage('SimpleChart');

	  $context['bbc_tags'][count($context['bbc_tags']) - 1][] = array(
		 'image' => 'chart_help',
		 'code' => 'chart2',
	 );

}

?>